package com.dzeio.openhealth.adapters

import android.view.LayoutInflater
import android.view.ViewGroup
import com.dzeio.openhealth.Settings
import com.dzeio.openhealth.core.BaseAdapter
import com.dzeio.openhealth.core.BaseViewHolder
import com.dzeio.openhealth.databinding.LayoutExtensionItemBinding
import com.dzeio.openhealth.extensions.Extension
import com.dzeio.openhealth.utils.Configuration


class ExtensionAdapter(
    private val config: Configuration
) : BaseAdapter<Extension, LayoutExtensionItemBinding>() {

    override val bindingInflater: (LayoutInflater, ViewGroup?, Boolean) ->
    LayoutExtensionItemBinding = LayoutExtensionItemBinding::inflate

    var onItemClick: ((weight: Extension) -> Unit)? = null

    override fun onBindData(
        holder: BaseViewHolder<LayoutExtensionItemBinding>,
        item: Extension,
        position: Int
    ) {
        val isEnabled = config.getBoolean(Settings.extensionEnabled(item)).value ?: false
        holder.binding.name.text = item.name
        holder.binding.card.isClickable = item.isAvailable()
        holder.binding.card.isEnabled = item.isAvailable()
        holder.binding.status.text = "enabled = $isEnabled"
        if (item.isAvailable()) {
            holder.binding.card.setOnClickListener {
                onItemClick?.invoke(item)
            }
        }
    }
}
