package com.dzeio.openhealth.extensions

import android.os.Build

class ExtensionFactory {
    companion object {
        fun getExtension(extension: String): Extension? {
            return when (extension) {
                "GoogleFit" -> {
                    GoogleFitExtension()
                }
                "HealthConnect" -> {
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
                        HealthConnectExtension()
                    } else {
                        TODO("VERSION.SDK_INT < P")
                    }
                }
                else -> {
                    null
                }
            }
        }

        fun getAll(): ArrayList<Extension> {
            val extensions: ArrayList<Extension> = arrayListOf(
                GoogleFitExtension()
            )

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.P) {
                extensions.add(HealthConnectExtension())
            }

            return extensions
        }
    }
}
